#### Activity
# Getting Abstract!
Inquiry Activity

### Learning Objective:
* [LO 2.2.3] Identify multiple levels of abstractions that are used when writing programs.
* [LO 6.1.1] Explain the abstractions in the Internet and how the Internet functions. [P3]
 
**Prompt: What makes a book a book?**
 
 
Abstraction is something we use every day in our lives without even thinking about it!
 
Choose a common everyday object to use as the focus of your discussion. For the purpose of illustrating the exercise, we'll use a book as the object. 
 
1. Write the word "book" in the middle of the board and circle it.
2. Ask the students, "Ok, but what makes you think this is a book? What *is* a book?
3. Continue to write the students' answers on the board, surrounding the word "book". 
On the left, write things that describe the physical properties of the book like: "it has pages", "it has a cover", "there are words in it".
On the right, write things that describe the idea or purpose of a book: "it contains facts or ideas", "it tells a story", "it describes characters and events", "it has action and adventure and romance".
4. Depending on the students' answers, steer the discussion until you have filled in details on both sides. For example:
"How do you know *this* is a book? You can't see the writing on the pages from there. You haven't seen the story, or the ideas inside. What about this object makes you think it's a book?"
"These things describe what a book is, physically… but some books aren't made of paper, they're electronic. Are both of those things books? When you write a book report, you don't usually say things like 'It is rectangular, and made of cardboard and paper and ink'. How do you think about a book when writing a report?"
5. Then ask the students to go to an even lower level of abstraction:
> "Ok, so this is a book because it's a sortof flat rectangular object made of paper, with some cardboard on the top and bottom and along one edge. But how do you know it's made of these things? Light is reflecting off the book into your eyes. Your eye turns the light into electrical impulses in your optical nerve, and that leads to chemical reactions in your brain, which access this abstract idea of a "book" in your mind. So is this bunch of paper and cardboard a book, or is the book the idea you use as an abstraction of this whole collection of properties?"
6. "So this book contains knowledge and ideas and stories and emotions. Those things started out as a series of chemical reactions in the authors brain, which they translated into letters and words and sentences, which they translated into ink making shapes on paper, which was sent through time and space to you, where you converted it back into chemicals in your brain that represent - maybe -the same ideas and knowledge and emotions that the author had. This is similar to the way computers work. The computer only knows about 1's and 0's. But through a series of abstractions, it converts these 1's and 0's into electrical impulses in wires, or radio waves for wireless signals… and another computer receives those signals and translates them back into 1's and 0's, and then into letters and words and images."
7. At the end, you should have the word "book" in the middle of the board, circled. Surrounding it are a lot of other things that make up the concept of a book, from chemicals in a brain, to stories of adventure or scientific knowledge.
 
**Prompt: What abstractions are used when writing programs?**

Now that students have an understanding of what an abstraction is, ask them for examples of abstractions they’ve seen or used while coding and during the course. Students should identify multiple levels of abstractions. Here are some  example abstractions that they will have seen in the course so far:

The game engine. “moveRight” abstracts out a great deal of animation and physics.
The language itself. An action as simple as setting a variable causes a great number of things to happen behind the scenes. The computer sets aside memory, it keeps track of the name and the value. Defining functions, mathematical and logical actions are all abstracted away for the convenience of the programmer. Strings, numbers, booleans are all abstracted. Often times languages will be turned into machine code, a much lower-level language, in order to run a program.
Previous activities, such as How the Internet Works, will have touched on abstractions such as an IP address. An IP address just links to “a device” but that device may change, and it could be any sort of device. The internet itself has [seven layers of abstraction](https://en.wikipedia.org/wiki/OSI_model).

**Prompt: What abstractions are there in how the internet is structured?**

Segue into discussing abstractions in the internet. Review what was covered in the How the Internet Works activity and discuss which of those are examples of abstractions (especially protocols).

An IP address is an abstraction for a device on the internet
TCP/IP is an abstraction of a connection. While it’s actually a bunch of separate packets going between two machines, it can be treated as a direct connection between two machines.
DNS is an abstraction of IP addresses. A service could change IP address but retain the same address which appears in the browser.

**Assessment questions:**
- What is an example of multiple levels of abstraction when programming? [LO 2.2.3]
- What is an example of a high-level programming language? A low-level programming language? How are they different? What purposes do they serve? [EK 2.2.3B]
- How is a website or powerpoint presentation a combination of lower abstractions? [EK 2.2.3K]
- What are three abstractions fundamental to the functioning of the Internet? How do they manage complexity? [EK 6.1.1E, EK 6.1.1G, EK 6.1.1I]
