# CodeCombat Clever Integration FAQ

#### Table of Contents
- [Our school district already uses Clever. How do I connect CodeCombat?](#our-school-district-already-uses-clever-how-do-i-connect-codecombat-)  
- [How do my students and teachers log into CodeCombat using Clever?](#how-do-my-students-and-teachers-log-into-codecombat-using-clever-)  
- [Our school district doesn’t use Clever yet. How do I sign up for Clever?](#our-school-district-doesn-t-use-clever-yet-how-do-i-sign-up-for-clever-)  
- [Do you offer a free CodeCombat trial for Clever users?](#do-you-offer-a-free-codecombat-trial-for-clever-users-)  
- [Some of our schools already use CodeCombat - how do I migrate their data into Clever?](#some-of-our-schools-already-use-codecombat-how-do-i-migrate-their-data-into-clever-)  
- [What if a student already has a CodeCombat account using their email address?](#what-if-a-student-already-has-a-codecombat-account-using-their-email-address-)


### Our school district already uses Clever. How do I connect CodeCombat? 
1. [Log into Clever as an District Aministrator](https://clever.com/oauth/district_admin/login)
2. On the left side of your dashboard, click “Add Applications”. 
3. Search for **“CodeCombat”** (no spaces), then click “Select”, and “Next” to continue. 

<img src="http://files.codecombat.com/docs/clever-faq/add-application.png" title="Add CodeCombat Application" alt="add-application" width="500px" />

  On the confirmation page, you’ll need to select whether you’ve already purchased student licenses to use with CodeCombat.

<img src="http://files.codecombat.com/docs/clever-faq/confirm-application.png" title="Confirm CodeCombat Application" alt="confirm-application" width="500px" />


If you’ve already purchased student licenses, select the **“Already Purchased”** option on the confirmation page. Our team will approve your request and make sure your licenses work properly.

If you haven’t already purchased student licenses, select the **“Haven’t Purchased”** option on the confirmation page. Our team will be in touch about licensing for your school and next steps. 


### How do my students and teachers log into CodeCombat using Clever? 
Once we’ve approved your CodeCombat integration, schools you’ve approved to use CodeCombat will see CodeCombat on their Clever portal — they will be instantly logged into CodeCombat when they click the CodeCombat icon. 

<img src="http://files.codecombat.com/docs/clever-faq/coco-logo.png" title="CodeCombat" alt="CodeCombat" />

New teachers will need to **Create a New Class**, then share the Class Code or Class URL with their students to make sure they join the correct class. 

Students will need to get the Class Code from their teacher before they are able to play CodeCombat. Once they have joined their class, they will automatically be assigned Introduction to Computer Science. 

Teachers can assign additional courses through their dashboard. 


### Our school district doesn’t use Clever yet. How do I sign up for Clever? 
You can find details on how to use Clever in your school district here: 
https://clever.com/schools 

If you’d like to just use CodeCombat in your school district without Clever, you can get started by [requesting a demo](/teachers/demo). 

### Do you offer a free CodeCombat trial for Clever users? 
Yes! Our **Introduction to Computer Science** is free to try with your students. You will still need to go through the approval process outlined above to access the trial if you’d like to use Clever. 


### Some of our schools already use CodeCombat - how do I migrate their data into Clever? 
We don’t currently have a way for schools with existing CodeCombat classes to link their Clever accounts. 
 
Please email [team@codecombat.com](mailto:team@codecombat.com) if you would like to see this feature supported.


### What if a student already has a CodeCombat account using their email address? 
We don’t currently have a way for students or teachers with existing CodeCombat accounts to link their accounts together. If they already have an account on CodeCombat with the same email address as their Clever account, a new account will be created when they log in via the Clever portal. They can continue to use the two separate accounts as if they were distinct. 
 
Please email [team@codecombat.com](mailto:team@codecombat.com) if you would like to see this feature supported.
 
